<?php
/*******************************************************************
 *          
 *          Fichier         :   install.php 
 *          Cr le         :   30 juillet 2002 
 *          Dernire modif  :   14 avril 2006
 *          Email           :   wascripts@phpcodeur.net 
 * 
 *              Copyright  2002-2006 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 *  modify it under the terms of the GNU General Public License as 
 *  published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


define('IN_INSTALL', true);

require('./setup.inc.php');

$lang  = $datetime = $msg_error = array();
$error = FALSE;

$vararray = array('start', 'confirm', 'send_file');
foreach( $vararray AS $varname )
{
    ${$varname} = ( isset($_POST[$varname]) ) ? true : false;
}

$vararray = array(
    'language', 'prev_language', 'type', 'admin_login', 'admin_email', 'admin_pass', 
    'confirm_pass', 'urlsite', 'urlscript'
);
foreach( $vararray AS $varname )
{
    ${$varname} = ( !empty($_POST[$varname]) ) ? trim($_POST[$varname]) : '';
}

$confirm_pass   = ( $confirm_pass != '' ) ? md5($confirm_pass) : '';
$language       = ( $language != '' ) ? $language : $default_lang;

if( isset($supported_db[$dbtype]) )
{
    include($waroot . 'sql/' . $dbtype . '.php');
}
else if( defined('NL_INSTALLED') || $start == true )
{
    plain_error('Le type de base de donnes n\'est pas dfini !');
}

$output->set_filenames( array(
    'body' => 'install.tpl'
));

if( $type != 'reinstall' && $type != 'update' )
{
    $type = 'install';
    
    if( $start )
    {
        if( $language != $prev_language )
        {
            $start = FALSE;
        }
    }
    else if( server_info('HTTP_ACCEPT_LANGUAGE') != '' )
    {
        $accept_lang_ary = array_map('trim', explode(',', server_info('HTTP_ACCEPT_LANGUAGE')));
        
        foreach( $accept_lang_ary AS $accept_lang )
        {
            $accept_lang = strtolower(substr($accept_lang, 0, 2));
            
            if( isset($supported_lang[$accept_lang]) && file_exists($waroot . 'language/lang_' . $supported_lang[$accept_lang] . '.php') )
            {
                $language = $supported_lang[$accept_lang];
                break;
            }
        }
    }
}

if( defined('NL_INSTALLED') )
{
    $db = new sql($dbhost, $dbuser, $dbpassword, $dbname);
    
    if( !$db->connect_id )
    {
        plain_error('Impossible de se connecter  la base de donnes');
    }
    
    $sql = "SELECT language, urlsite, path, version, hebergeur FROM " . CONFIG_TABLE;
    if( !($result = $db->query($sql)) )
    {
        plain_error('Impossible d\'obtenir la configuration du script');
    }
    
    $old_config = $db->fetch_array($result);
    
    $old_version = $old_config['version'];
    $urlsite     = $old_config['urlsite'];
    $urlscript   = $old_config['path'];
    $language    = $old_config['language'];
    $hebergeur   = $old_config['hebergeur'];
    
    require($waroot . 'language/lang_' . $language . '.php');
    
    $login = FALSE;
    
    if( $confirm )
    {
        $sql = "SELECT admin_email, admin_pwd, admin_level 
            FROM " . ADMIN_TABLE . " 
            WHERE LOWER(admin_login) = '" . $db->escape(strtolower($admin_login)) . "'";
        if( $result = $db->query($sql) )
        {
            if( $row = $db->fetch_array($result) )
            {
                if( md5($admin_pass) == $row['admin_pwd'] && $row['admin_level'] == ADMIN )
                {
                    $login        = TRUE;
                    $start        = TRUE;
                    $admin_email  = $row['admin_email'];
                    $confirm_pass = $row['admin_pwd'];
                }
            }
        }
        
        if( !$login )
        {
            $error = TRUE;
            $msg_error[] = $lang['Message']['Error_login'];
        }
    }
}
else
{
    if( $start )
    {
        $db = new sql($dbhost, $dbuser, $dbpassword, $dbname);
        
        if( !$db->connect_id )
        {
            $error = TRUE;
            $msg_error[] = '<b>Impossible de se connecter  la base de donnes</b>';
        }
        
        if( !is_writable($waroot . 'includes/config.inc.php') )
        {
            $error = TRUE;
            $msg_error[] = 'Le fichier de configuration n\'est pas accessible en criture';
        }
    }
    
    include($waroot . 'language/lang_' . $language . '.php');
}

$output->send_headers();

$output->assign_vars( array(
    'PAGE_TITLE'    => ( defined('NL_INSTALLED') ) ? $lang['Title']['reinstall_update'] : $lang['Title']['install'],
    'CONTENT_LANG'  => $lang['CONTENT_LANG'],
    'CONTENT_DIR'   => $lang['CONTENT_DIR'],
    'NEW_VERSION'   => $new_version,
    'TRANSLATE'     => ( $lang['TRANSLATE'] != '' ) ? ' | Translate by ' . $lang['TRANSLATE'] : ''
));

if( defined('NL_INSTALLED') && ( !$start || $error ) )
{
    $output->assign_block_vars('reinstall', array(
        'L_EXPLAIN_REINSTALL'   => nl2br($lang['Warning_reinstall']),
        'L_LOGIN'               => $lang['Login'],
        'L_PASS'                => $lang['Password'],
        'L_SELECT_TYPE'         => $lang['Select_type'],
        'L_TYPE_REINSTALL'      => $lang['Type_reinstall'],
        'L_TYPE_UPDATE'         => $lang['Type_update'],
        'L_CONF_BUTTON'         => $lang['Button']['conf']
    ));
    
    if( $error )
    {
        $output->error_box($msg_error);
    }
    
    $output->pparse('body');
    exit;
}

if( $send_file )
{
    include($waroot . 'includes/class.attach.php');
    
    Attach::send_file('config.inc.php', 'text/plain', $config_file);
    exit;
}
else
{
    if( $start )
    {
        include($waroot . 'includes/functions.validate.php');
        
        if( $dbhost == '' || $dbname == '' || $dbuser == '' || $prefixe == '' || $admin_login == '' )
        {
            $error = TRUE;
            $msg_error[] = $lang['Message']['fields_empty'];
        }
        
        if( !validate_pass($admin_pass) )
        {
            $error = TRUE;
            $msg_error[] = $lang['Message']['Alphanum_pass'];
        }
        else if( md5($admin_pass) != $confirm_pass )
        {
            $error = TRUE;
            $msg_error[] = $lang['Message']['Bad_confirm_pass'];
        }
        
        $result = check_email($admin_email);
        
        if( $result['error'] )
        {
            $error = TRUE;
            $msg_error[] = $result['message'];
        }
        
        $urlsite = preg_replace('/^http(s)?:\/\/(.*?)\/?$/i', 'http\\1://\\2', $urlsite);
        
        if( $urlscript != '/' )
        {
            $urlscript = preg_replace('/^\/?(.*?)\/?$/i', '/\\1/', $urlscript);
        }
        
        //
        // On allonge le temps maximum d'execution du script. 
        //
        @set_time_limit(120);
        
        if( ( $type == 'install' || $type == 'reinstall' ) && !$error )
        {
            $db->transaction(START_TRC);
            
            if( $type == 'reinstall' )
            {
                exec_queries(str_replace('wa_', $prefixe, $sql_drop_table));
                
                if( $dbtype == 'postgre' )
                {
                    exec_queries(str_replace('wa_', $prefixe, $sql_drop_index));
                    exec_queries(str_replace('wa_', $prefixe, $sql_drop_sequence));
                }
            }
            
            //
            // Cration des tables du script 
            //
            $sql_file = $schemas_dir . $supported_db[$dbtype]['prefixe_file'] . '_tables.sql';
            
            if( !($fp = @fopen($sql_file, 'r')) )
            {
                msg_result('sql_file_not_readable');
            }
            
            $sql_create = make_sql_ary(fread($fp, filesize($sql_file)), $supported_db[$dbtype]['delimiter'], $prefixe);
            fclose($fp);
            
            exec_queries($sql_create, true);
            
            //
            // Insertion des donnes de base 
            //
            $sql_file = $schemas_dir . $supported_db[$dbtype]['prefixe_file'] . '_data.sql';
            
            if( !($fp = @fopen($sql_file, 'r')) )
            {
                msg_result('sql_file_not_readable');
            }
            
            $sql_data = make_sql_ary(fread($fp, filesize($sql_file)), $supported_db[$dbtype]['delimiter2'], $prefixe);
            fclose($fp);
            
            $sql_data[] = "UPDATE " . ADMIN_TABLE . " SET admin_login = '" . $db->escape($admin_login) . "', admin_pwd = '" . md5($admin_pass) . "', admin_email = '$admin_email', admin_lang = '$language' WHERE admin_id = 1";
            $sql_data[] = "UPDATE " . CONFIG_TABLE . " SET urlsite = '$urlsite', path = '$urlscript', language = '$language', mailing_startdate = " . time() . ", version = '$new_version'";
            $sql_data[] = "UPDATE " . LISTE_TABLE . " SET liste_startdate = " . time() . " WHERE liste_id = 1";
            
            exec_queries($sql_data, true);
            
            $db->transaction(END_TRC);
        }
        else if( $type == 'update' && !$error )
        {
            $sql_update = array();
            
            switch( $old_version )
            {
                case '2.2-Beta':
                case '2.2-Beta2':
                    switch( DATABASE )
                    {
                        case 'mssql':
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . "
                                ALTER COLUMN [smtp_user] [varchar] (50) NOT NULL";
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . "
                                ALTER COLUMN [smtp_pass] [varchar] (50) NOT NULL";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " ADD 
                                liste_alias varchar(250) NOT NULL, 
                                use_cron smallint NOT NULL, 
                                pop_host varchar(100) NOT NULL, 
                                pop_port smallint NOT NULL, 
                                pop_user varchar(50) NOT NULL, 
                                pop_pass varchar(50) NOT NULL, 
                                liste_alias varchar(250) NOT NULL, 
                                CONSTRAINT [DF_" . LISTE_TABLE . "_use_cron] DEFAULT (0) FOR [use_cron], 
                                CONSTRAINT [DF_" . LISTE_TABLE . "_pop_port] DEFAULT (110) FOR [pop_port]";
                            break;
                        
                        case 'postgre':
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . "
                                RENAME COLUMN smtp_user TO smtp_user_old, 
                                RENAME COLUMN smtp_pass TO smtp_pass_old";
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . "
                                ADD COLUMN smtp_user varchar(50) NOT NULL DEFAULT '', 
                                ADD COLUMN smtp_pass varchar(50) NOT NULL DEFAULT ''";
                            $sql_update[] = "UPDATE " . CONFIG_TABLE . " SET smtp_user = smtp_user_old, smtp_pass = smtp_pass_old";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN liste_alias varchar(250) NOT NULL DEFAULT ''";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN use_cron int NOT NULL DEFAULT '0'";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN pop_host varchar(100) NOT NULL DEFAULT ''";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN pop_port int2 NOT NULL DEFAULT '110'";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN pop_user varchar(50) NOT NULL DEFAULT ''";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN pop_pass varchar(50) NOT NULL DEFAULT ''";
                            break;
                        
                        default:
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
                                MODIFY COLUMN smtp_user varchar(50) NOT NULL DEFAULT '', 
                                MODIFY COLUMN smtp_pass varchar(50) NOT NULL DEFAULT ''";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN liste_alias varchar(250) NOT NULL DEFAULT '', 
                                ADD COLUMN use_cron tinyint(1) NOT NULL DEFAULT '0',
                                ADD COLUMN pop_host varchar(100) NOT NULL DEFAULT '',
                                ADD COLUMN pop_port smallint(5) NOT NULL DEFAULT '110',
                                ADD COLUMN pop_user varchar(50) NOT NULL DEFAULT '',
                                ADD COLUMN pop_pass varchar(50) NOT NULL DEFAULT ''";
                            break;
                    }
                    
                    if( $hebergeur == 3 )
                    {
                        $sql_update[] = "UPDATE " . CONFIG_TABLE . " SET hebergeur = 1";
                    }
                
                //
                // Un bug tait prsent dans la rc1, comme une seconde dition du package avait t mise 
                //  disposition pour pallier  un bug de dernire minute assez important, le numro de version 
                // tait 2.2-RC2 pendant une dizaine de jours (alors qu'il me semblait avoir recorrig 
                // le package aprs coup). 
                // Nous effectuons donc la mise  jour galement pour les versions 2.2-RC2. 
                // Le nom de la vrai release candidate 2 est donc 2.2-RC2b pour viter des problmes lors des mises 
                //  jour par les gens qui ont tlcharg le package les dix premiers jours.
                //
                case '2.2-RC1':
                case '2.2-RC2':
                    //
                    // Suppression des ventuelles entres orphelines dans les tables abonnes et abo_liste
                    //
                    $sql = "SELECT abo_id 
                        FROM " . ABONNES_TABLE;
                    if( !($result = $db->query($sql)) )
                    {
                        msg_result($sql, true);
                    }
                    
                    $abonnes_id = array();
                    while( $row = $db->fetch_array($result) )
                    {
                        $abonnes_id[] = $row['abo_id'];
                    }
                    
                    $sql = "SELECT abo_id 
                        FROM " . ABO_LISTE_TABLE . " 
                        GROUP BY abo_id";
                    if( !($result = $db->query($sql)) )
                    {
                        msg_result($sql, true);
                    }
                    
                    $abo_liste_id = array();
                    while( $row = $db->fetch_array($result) )
                    {
                        $abo_liste_id[] = $row['abo_id'];
                    }
                    
                    $diff_1 = array_diff($abonnes_id, $abo_liste_id);
                    $diff_2 = array_diff($abo_liste_id, $abonnes_id);
                    
                    $total_diff_1 = count($diff_1);
                    $total_diff_2 = count($diff_2);
                    
                    if( $total_diff_1 > 0 )
                    {
                        $sql_update[] = "DELETE FROM " . ABONNES_TABLE . " 
                            WHERE abo_id IN(" . implode(', ', $diff_1) . ")";
                    }
                    
                    if( $total_diff_2 > 0 )
                    {
                        $sql_update[] = "DELETE FROM " . ABO_LISTE_TABLE . " 
                            WHERE abo_id IN(" . implode(', ', $diff_2) . ")";
                    }
                    
                    switch( DATABASE )
                    {
                        case 'mssql':
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " ADD 
                                liste_numlogs smallint NOT NULL, 
                                CONSTRAINT [DF_" . LISTE_TABLE . "_liste_numlogs] DEFAULT (0) FOR [liste_numlogs]";
                            $sql_update[] = "ALTER TABLE " . LOG_TABLE . " ADD 
                                log_numdest smallint NOT NULL, 
                                CONSTRAINT [DF_" . LOG_TABLE . "_log_numdest] DEFAULT (0) FOR [log_numdest]";
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " ADD 
                                check_email_mx smallint NOT NULL, 
                                CONSTRAINT [DF_" . CONFIG_TABLE . "_check_email_mx] DEFAULT (0) FOR [check_email_mx]";
                            $sql_update[] = "DROP INDEX " . ABO_LISTE_TABLE . ".IX_" . ABO_LISTE_TABLE;
                            $sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " ADD 
                                CONSTRAINT [PK_" . ABO_LISTE_TABLE . "] PRIMARY KEY CLUSTERED ([abo_id], [liste_id]) ON [PRIMARY]";
                            $sql_update[] = "DROP INDEX " . LOG_FILES_TABLE . ".IX_" . LOG_FILES_TABLE;
                            $sql_update[] = "ALTER TABLE " . LOG_FILES_TABLE . " ADD 
                                CONSTRAINT [PK_" . LOG_FILES_TABLE . "] PRIMARY KEY CLUSTERED ([log_id], [file_id]) ON [PRIMARY]";
                            break;
                        
                        case 'postgre':
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN liste_numlogs int2 NOT NULL";
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ALTER COLUMN liste_numlogs SET DEFAULT '0'";
                            $sql_update[] = "ALTER TABLE " . LOG_TABLE . " 
                                ADD COLUMN log_numdest int2 NOT NULL";
                            $sql_update[] = "ALTER TABLE " . LOG_TABLE . " 
                                ALTER COLUMN log_numdest SET DEFAULT '0'";
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
                                ADD COLUMN check_email_mx int NOT NULL";
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
                                ALTER COLUMN check_email_mx SET DEFAULT '0'";
                            break;
                        
                        default:
                            $sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
                                ADD COLUMN liste_numlogs smallint(5) NOT NULL DEFAULT '0' AFTER liste_alias";
                            $sql_update[] = "ALTER TABLE " . LOG_TABLE . " 
                                ADD COLUMN log_numdest smallint(5) NOT NULL DEFAULT '0' AFTER log_date";
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
                                ADD COLUMN check_email_mx tinyint(1) NOT NULL DEFAULT '0' AFTER gd_img_type";
                            $sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " DROP INDEX `abo_id`";
                            $sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " DROP INDEX `liste_id`";
                            $sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " 
                                ADD PRIMARY KEY (abo_id , liste_id)";
                            $sql_update[] = "ALTER TABLE " . LOG_FILES_TABLE . " DROP INDEX `log_id`";
                            $sql_update[] = "ALTER TABLE " . LOG_FILES_TABLE . " DROP INDEX `file_id`";
                            $sql_update[] = "ALTER TABLE " . LOG_FILES_TABLE . " 
                                ADD PRIMARY KEY (log_id , file_id)";
                            break;
                    }
                    
                    $sql = "SELECT COUNT(*) AS numlogs, liste_id 
                        FROM " . LOG_TABLE . " 
                        WHERE log_status = " . STATUS_SENDED . " 
                        GROUP BY liste_id";
                    if( !($result = $db->query($sql)) )
                    {
                        msg_result($sql, true);
                    }
                    
                    while( $row = $db->fetch_array($result) )
                    {
                        $sql_update[] = "UPDATE " . LISTE_TABLE . " 
                            SET liste_numlogs = " . $row['numlogs'] . " 
                            WHERE liste_id = " . $row['liste_id'];
                    }
                    
                    $sql = "SELECT COUNT(DISTINCT(a.abo_id)) AS num_dest, al.liste_id 
                        FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
                        WHERE a.abo_id = al.abo_id AND a.abo_status = " . ABO_ACTIF . " 
                        GROUP BY al.liste_id";
                    if( !($result = $db->query($sql)) )
                    {
                        msg_result($sql, true);
                    }
                    
                    while( $row = $db->fetch_array($result) )
                    {
                        $sql_update[] = "UPDATE " . LOG_TABLE . " 
                            SET log_numdest = " . $row['num_dest'] . " 
                            WHERE liste_id = " . $row['liste_id'];
                    }
                
                case '2.2-RC2b':
                    switch( DATABASE )
                    {
                        case 'mssql':
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " ADD 
                                enable_profil_cp smallint NOT NULL, 
                                CONSTRAINT [DF_" . CONFIG_TABLE . "_enable_profil_cp] DEFAULT (0) FOR [enable_profil_cp]";
                            $sql_update[] = "ALTER TABLE " . ABONNES_TABLE . " ADD abo_lang varchar(30) NOT NULL";
                            break;
                        
                        case 'postgre':
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
                                ADD COLUMN enable_profil_cp int NOT NULL DEFAULT '0'";
                            $sql_update[] = "ALTER TABLE " . ABONNES_TABLE . " 
                                ADD COLUMN abo_lang varchar(30) NOT NULL DEFAULT ''";
                            break;
                        
                        default:
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
                                ADD COLUMN enable_profil_cp tinyint(1) NOT NULL DEFAULT '0' AFTER check_email_mx";
                            $sql_update[] = "ALTER TABLE " . ABONNES_TABLE . " 
                                ADD COLUMN abo_lang varchar(30) NOT NULL DEFAULT '' AFTER abo_email";
                            break;
                    }
                    
                    //
                    // Correction du bug de mise  jour de la table abo_liste aprs un envoi.
                    // Si tous les abonns d'une liste ont send  1, on remet celui ci 0
                    //
                    $sql = "SELECT COUNT(al.abo_id) AS num_abo, SUM(al.send) AS num_send, al.liste_id 
                        FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
                        WHERE a.abo_id = al.abo_id AND a.abo_status = " . ABO_ACTIF . " 
                        GROUP BY al.liste_id";
                    if( !($result = $db->query($sql)) )
                    {
                        msg_result($sql, true);
                    }
                    
                    while( $row = $db->fetch_array($result) )
                    {
                        if( $row['num_abo'] == $row['num_send'] )
                        {
                            $sql_update[] = "UPDATE " . ABO_LISTE_TABLE . " 
                                SET send = 0 WHERE liste_id = " . $row['liste_id'];
                        }
                    }
                    
                    $sql_update[] = "UPDATE " . ABONNES_TABLE . " SET abo_lang = '$language'";
                
                case '2.2-RC3':
                    switch( DATABASE )
                    {
                        case 'mssql':
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " ADD 
                                ftp_port smallint NOT NULL, 
                                CONSTRAINT [DF_" . CONFIG_TABLE . "_ftp_port] DEFAULT (21) FOR [ftp_port]";
                            break;
                        
                        case 'postgre':
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
                                ADD COLUMN ftp_port int NOT NULL DEFAULT '21'";
                            break;
                        
                        default:
                            $sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
                                ADD COLUMN ftp_port smallint(5) NOT NULL DEFAULT '21' AFTER ftp_server";
                            $sql_update[] = "ALTER TABLE " . ABONNES_TABLE . " 
                                CHANGE abo_id abo_id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT";
                            $sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " 
                                CHANGE abo_id abo_id MEDIUMINT(8) UNSIGNED DEFAULT '0' NOT NULL";
                            break;
                    }
                    
                case '2.2-RC4':
                case '2.2.0':
                case '2.2.1':
                case '2.2.2':
                case '2.2.3':
                case '2.2.4':
                    //
                    // On dsactive la vrification approfondie des adresses email, pas encore au point...
                    //
                    $sql_update[] = "UPDATE " . CONFIG_TABLE . " SET check_email_mx = 0";
				case '2.2.5':
				case '2.2.6':
				case '2.2.7':
				case '2.2.8':
				case '2.2.9':
				case '2.2.10':
                    break;
                
                default:
                    msg_result($lang['Update_not_required']);
                    break;
            }
            
            $sql_update[] = "UPDATE " . CONFIG_TABLE . " SET version = '$new_version'";
            
            exec_queries($sql_update, true);
        }// end if update
        
        $db->close_connexion();
        
        if( !$error )
        {
            if( $type == 'install' || $type == 'reinstall' )
            {
                $l_title = $lang['Result_install'];
            }
            else
            {
                $l_title = $lang['Result_update'];
            }
            
            if( $type == 'install' )
            {
                @chmod($waroot . 'includes/config.inc.php', 0666);
                
                if( !($fw = @fopen($waroot . 'includes/config.inc.php', 'w')) )
                {
                    $output->addHiddenField('dbtype'    , $dbtype);
                    $output->addHiddenField('dbhost'    , $dbhost);
                    $output->addHiddenField('dbuser'    , $dbuser);
                    $output->addHiddenField('dbpassword', $dbpassword);
                    $output->addHiddenField('dbname'    , $dbname);
                    $output->addHiddenField('prefixe'   , $prefixe);
                    
                    $output->assign_block_vars('download_file', array(
                        'L_TITLE'         => $l_title,
                        'L_DL_BUTTON'     => $lang['Button']['dl'],
                        
                        'MSG_RESULT'      => nl2br($lang['Success_whithout_config']),                       
                        'S_HIDDEN_FIELDS' => $output->getHiddenFields()
                    ));
                    
                    $output->pparse('body');
                    exit;
                }
                
                fwrite($fw, $config_file);
                fclose($fw);
                
                @chmod($waroot . 'includes/config.inc.php', 0644);
            }
            
            if( $type == 'install' || $type == 'reinstall' )
            {
                $msg_result = $lang['Success_install'];
            }
            else
            {
                $msg_result = $lang['Success_update'];
            }
            
            $output->assign_block_vars('result', array(
                'L_TITLE'    => $l_title,
                'MSG_RESULT' => nl2br(sprintf($msg_result, '<a href="' . $waroot . 'admin/login.php">', '</a>'))
            ));
            
            $output->pparse('body');
            exit;
        }
    }
    
    include($waroot . 'includes/functions.box.php');
    $lang_box = lang_box($language);
    
    $db_box = '<select id="dbtype" name="dbtype">';
    foreach( $supported_db AS $db_name => $db_infos )
    {
        $selected = ( $dbtype == $db_name ) ? ' selected="selected"' : '';
        $db_box .= '<option value="' . $db_name . '"' . $selected . '> - ' . $db_infos['Name'] . ' - </option>';
    }
    $db_box .= '</select>';
    
    if( $urlsite == '' )
    {
        $urlsite = 'http://' . server_info('HTTP_HOST');
    }
    
    if( $urlscript == '' )
    {
        $urlscript = preg_replace('/^(.*?)\/setup\/?$/i', '\\1/', dirname(server_info('PHP_SELF')));
    }
    
    $output->addHiddenField('prev_language', $language);
    
    $output->assign_block_vars('welcome', array(
        'L_WELCOME'         => nl2br( sprintf($lang['Welcome_in_install'], '<a href="' . $waroot . 'docs/readme.' . $lang['CONTENT_LANG'] . '.html">', '</a>')),
        'TITLE_DATABASE'    => $lang['Title']['database'],
        'TITLE_ADMIN'       => $lang['Title']['admin'],
        'TITLE_DIVERS'      => $lang['Title']['config_divers'],
        'L_DBTYPE'          => $lang['dbtype'],
        'L_DBHOST'          => $lang['dbhost'],
        'L_DBNAME'          => $lang['dbname'],
        'L_DBUSER'          => $lang['dbuser'],
        'L_DBPWD'           => $lang['dbpwd'],
        'L_PREFIXE'         => $lang['prefixe'],
        'L_DEFAULT_LANG'    => $lang['Default_lang'],
        'L_LOGIN'           => $lang['Login'],
        'L_PASS'            => $lang['Password'],
        'L_PASS_CONF'       => $lang['Conf_pass'],
        'L_EMAIL'           => $lang['Email_address'],
        'L_URLSITE'         => $lang['Urlsite'],
        'L_URLSCRIPT'       => $lang['Urlscript'],
        'L_URLSITE_NOTE'    => $lang['Urlsite_note'],
        'L_URLSCRIPT_NOTE'  => $lang['Urlscript_note'],
        'L_BUTTON_START'    => $lang['Start_install'],
        
        'DB_BOX'            => $db_box,
        'DBHOST'            => htmlspecialchars(stripslashes($dbhost)),
        'DBNAME'            => htmlspecialchars(stripslashes($dbname)),
        'DBUSER'            => htmlspecialchars(stripslashes($dbuser)),
        'PREFIXE'           => htmlspecialchars(stripslashes($prefixe)),
        'LOGIN'             => htmlspecialchars(stripslashes($admin_login)),
        'EMAIL'             => htmlspecialchars(stripslashes($admin_email)),
        'URLSITE'           => htmlspecialchars(stripslashes($urlsite)),
        'URLSCRIPT'         => htmlspecialchars(stripslashes($urlscript)),
        
        'LANG_BOX'          => $lang_box,
        'S_HIDDEN_FIELD'    => $output->getHiddenFields()
    ));
    
    if( $error )
    {
        $output->error_box($msg_error);
    }
}

$output->pparse('body');
?>